import React, { Children, useRef, useState, useMemo, useEffect, useCallback } from 'react';
import MuiAlert from '@mui/material/Alert';
import Slide from '@mui/material/Slide';
import Snackbar from '@mui/material/Snackbar';
import { Stack, Typography, Divider, TextField as TextField$1, FormGroup, FormControlLabel, Checkbox, Box as Box$2, Tooltip, IconButton as IconButton$1, useTheme, useMediaQuery, Button as Button$1 } from '@mui/material';
import Box from '@mui/system/Box';
import { styled, ThemeProvider, createTheme, responsiveFontSizes, useTheme as useTheme$1 } from '@mui/material/styles';
import LinearProgress, { linearProgressClasses } from '@mui/material/LinearProgress';
import Box$1 from '@mui/material/Box';
import Button from '@mui/material/Button';
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import Stack$1 from '@mui/material/Stack';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { library, findIconDefinition } from '@fortawesome/fontawesome-svg-core';
import { fas } from '@fortawesome/free-solid-svg-icons';
import Typography$1 from '@mui/material/Typography';
import Grid from '@mui/material/Grid';
import Popover from '@mui/material/Popover';
import { styled as styled$1 } from '@mui/system';
import Paper from '@mui/material/Paper';
import IconButton from '@mui/material/IconButton';
import CloseIcon from '@mui/icons-material/Close';
import MobileDatePicker from '@mui/lab/MobileDatePicker';
import LocalizationProvider from '@mui/lab/LocalizationProvider';
import { AdapterMoment } from '@mui/x-date-pickers/AdapterMoment';
import TextField from '@mui/material/TextField';
import moment from 'moment';
import Autocomplete from '@mui/material/Autocomplete';
import CircularProgress from '@mui/material/CircularProgress';
import ClickAwayListener from '@mui/material/ClickAwayListener';
import PersonSearchIcon from '@mui/icons-material/PersonSearch';
import MapTwoToneIcon from '@mui/icons-material/MapTwoTone';
import CorporateFareIcon from '@mui/icons-material/CorporateFare';
import CardHeader from '@mui/material/CardHeader';
import Avatar from '@mui/material/Avatar';
import LocationOnTwoToneIcon from '@mui/icons-material/LocationOnTwoTone';
import { blue, grey } from '@mui/material/colors';
import { nanoid, createSlice } from '@reduxjs/toolkit';
import Divider$1 from '@mui/material/Divider';
import EditIcon from '@mui/icons-material/Edit';
import { GridLinkOperator, DataGridPro, GridToolbarContainer, GridToolbarFilterButton } from '@mui/x-data-grid-pro';
import { withNetworkCompletionDispatch } from '@nerdjs/nerd-network';
import DatePicker from '@mui/lab/DatePicker';
import TablePagination from '@mui/material/TablePagination';
import useMediaQuery$1 from '@mui/material/useMediaQuery';
import Pagination from '@mui/material/Pagination';
import { FirstPage, KeyboardArrowLeft, KeyboardArrowRight, SaveAlt } from '@mui/icons-material';

var BorderLinearProgress = /*#__PURE__*/styled(function (props) {
  var _props$color;

  return React.createElement(LinearProgress, {
    variant: props.variant,
    value: props.value,
    color: (_props$color = props.color) != null ? _props$color : "info"
  });
})(function (_ref) {
  var _ref2;

  var theme = _ref.theme;
  return _ref2 = {
    height: 5,
    borderRadius: 5
  }, _ref2["&." + linearProgressClasses.colorPrimary] = {
    backgroundColor: theme.palette.grey[theme.palette.mode === "light" ? 200 : 800]
  }, _ref2["& ." + linearProgressClasses.bar] = {
    borderRadius: 5,
    backgroundColor: theme.palette.mode === "light" ? "#1a90ff" : "#308fe8"
  }, _ref2;
});

var direction = undefined;
/**
 *
 * @param {NerdNotificationProps & openHookAction} param0 components props
 * @returns {JSX.Element} NonIntrusive nerdNotifier
 */

function NonIntrusive(_ref) {
  var uuid = _ref.uuid,
      title = _ref.title,
      _ref$transition = _ref.transition,
      transition = _ref$transition === void 0 ? "up" : _ref$transition,
      _ref$severity = _ref.severity,
      severity = _ref$severity === void 0 ? "info" : _ref$severity,
      subtitle = _ref.subtitle,
      body = _ref.body,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? {
    vertical: "bottom",
    horizontal: "right"
  } : _ref$position,
      actions = _ref.actions,
      _ref$autoHideDuration = _ref.autoHideDuration,
      autoHideDuration = _ref$autoHideDuration === void 0 ? 5000 : _ref$autoHideDuration,
      _ref$autohide = _ref.autohide,
      autohide = _ref$autohide === void 0 ? true : _ref$autohide,
      open = _ref.open,
      handleClose = _ref.handleClose,
      icon = _ref.icon,
      color = _ref.color;
  direction = transition;

  var _React$useState = React.useState(0),
      progress = _React$useState[0],
      setProgress = _React$useState[1];

  var timer = React.useRef(0);
  React.useEffect(function () {
    timer.current = window.setInterval(function () {
      setProgress(function (prevProgress) {
        return prevProgress >= 100 ? 0 : prevProgress + 10;
      });
    }, autoHideDuration / 10);
    return function () {
      clearInterval(timer.current);
    };
  }, []);
  React.useEffect(function () {
    if (progress >= 100 && autohide) {
      handleClose();
    }
  }, [progress, autohide]);

  if (icon) {
    return React.createElement(Alert, {
      severity: "warning",
      className: "nonIntrusive--unkown"
    }, "Unkown");
  }

  return React.createElement(Box, {
    component: "div",
    id: uuid
  }, React.createElement(Snackbar, {
    open: open,
    autoHideDuration: autohide ? autoHideDuration : null,
    TransitionComponent: Transition,
    anchorOrigin: position
  }, React.createElement(Stack, {
    spacing: 1
  }, autohide && React.createElement(BorderLinearProgress, {
    variant: "determinate",
    value: progress,
    color: severity
  }), React.createElement(Alert, {
    severity: severity,
    sx: {
      width: "100%",
      alignItems: "center",
      backgroundColor: color
    },
    action: actions,
    onClose: handleClose
  }, title && React.createElement(Typography, {
    variant: "body1"
  }, title), subtitle && React.createElement(Typography, {
    variant: "body2"
  }, subtitle), body && React.createElement(Typography, {
    variant: "caption"
  }, body)))));
}
var Alert = /*#__PURE__*/React.forwardRef(function Alert(props, ref) {
  return React.createElement(MuiAlert, Object.assign({
    ref: ref,
    variant: "filled"
  }, props));
});
/**
 *
 * @param {TransitionProps} props Component props
 * @returns {JSX.Element} Transition Component
 */

function Transition(props) {
  return React.createElement(Slide, Object.assign({}, props, {
    direction: direction
  }));
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

library.add(fas);
/**
 * This component is a wrapper for the FontAwesomeIcon component.
 * It is used to add icons to any library. More info here: https://fontawesome.com/v5/docs/web/use-with/react
 */

var NerdIcon = function NerdIcon(props) {
  var icon = props.icon,
      severity = props.severity,
      iconColor = props.iconColor,
      _props$size = props.size,
      size = _props$size === void 0 ? "3x" : _props$size,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave;

  if (!icon) {
    return null;
  }

  return React.createElement("span", {
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, typeof icon === "string" ? setCustomIconString(_extends({}, {
    icon: icon,
    severity: severity,
    iconColor: iconColor,
    size: size
  })) : React.createElement(FontAwesomeIcon, {
    icon: icon,
    size: size,
    color: iconColor != null ? iconColor : "#0288d1"
  }));
};
/**
 *
 * @param root0
 * @param root0.icon
 * @param root0.iconColor
 * @param root0.severity
 * @param root0.size
 */

function setCustomIconString(_ref) {
  var icon = _ref.icon,
      iconColor = _ref.iconColor,
      severity = _ref.severity,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? "3x" : _ref$size;
  return React.createElement(FontAwesomeIcon, {
    icon: setCustomIconDefinition(icon),
    color: iconColor && iconColor !== "" ? iconColor : colorSwitch(severity || "info"),
    size: size
  });
} //TODO: fontawesome-svg-core package needs to be updated. (v5.15.4 current version). The icons name are were changed.

/**
 *
 * @param icon
 */


function setCustomIconDefinition(icon) {
  var iconLookup = {
    prefix: "fas",
    iconName: icon
  };
  var customIconDefinition = findIconDefinition(iconLookup);
  return customIconDefinition;
}
/**
 *
 * @param color
 */

function colorSwitch(color) {
  switch (color) {
    case "error":
      return "#d32f2f";

    case "info":
      return "#0288d1";

    case "success":
      return "#2e7d32";

    case "warning":
      return "#ed6c02";

    default:
      return "#000";
  }
}

var e=[],t=[];function n(n,r){if(n&&"undefined"!=typeof document){var a,s=!0===r.prepend?"prepend":"append",d=!0===r.singleTag,i="string"==typeof r.container?document.querySelector(r.container):document.getElementsByTagName("head")[0];if(d){var u=e.indexOf(i);-1===u&&(u=e.push(i)-1,t[u]={}),a=t[u]&&t[u][s]?t[u][s]:t[u][s]=c();}else a=c();65279===n.charCodeAt(0)&&(n=n.substring(1)),a.styleSheet?a.styleSheet.cssText+=n:a.appendChild(document.createTextNode(n));}function c(){var e=document.createElement("style");if(e.setAttribute("type","text/css"),r.attributes)for(var t=Object.keys(r.attributes),n=0;n<t.length;n++)e.setAttribute(t[n],r.attributes[t[n]]);var a="prepend"===s?"afterbegin":"beforeend";return i.insertAdjacentElement(a,e),e}}

var css = ".nonIntrusive--unkown {\n  position: absolute;\n  width: 30%;\n  bottom: 0;\n  right: 10px;\n}\n\n.NerdNotifierIntrusivePaper .IntrusiveIcon {\n  display: flex;\n  margin-top: 1rem;\n  justify-content: center;\n}";
n(css,{});

/**
 *
 * @param {NerdNotificationProps & openHookAction} param0 Component props
 * @returns {JSX.Element} Intrusive nerdNotifier
 */

function Intrusive(_ref) {
  var _severityIcons;

  var title = _ref.title,
      subtitle = _ref.subtitle,
      body = _ref.body,
      icon = _ref.icon,
      actions = _ref.actions,
      _ref$severity = _ref.severity,
      severity = _ref$severity === void 0 ? "info" : _ref$severity,
      open = _ref.open,
      iconColor = _ref.iconColor,
      _ref$autoHideDuration = _ref.autoHideDuration,
      autoHideDuration = _ref$autoHideDuration === void 0 ? 5000 : _ref$autoHideDuration,
      _ref$autohide = _ref.autohide,
      autohide = _ref$autohide === void 0 ? true : _ref$autohide,
      _ref$showIcon = _ref.showIcon,
      showIcon = _ref$showIcon === void 0 ? true : _ref$showIcon,
      onHandleClose = _ref.onHandleClose,
      _ref$unstyled = _ref.unstyled,
      unstyled = _ref$unstyled === void 0 ? true : _ref$unstyled,
      _ref$actionPrimaryPro = _ref.actionPrimaryProps,
      actionPrimaryProps = _ref$actionPrimaryPro === void 0 ? {
    variant: "text",
    color: "primary"
  } : _ref$actionPrimaryPro,
      _ref$actionSecondaryP = _ref.actionSecondaryProps,
      actionSecondaryProps = _ref$actionSecondaryP === void 0 ? {
    variant: "text",
    color: "inherit"
  } : _ref$actionSecondaryP;

  var _React$useState = React.useState(0),
      progress = _React$useState[0],
      setProgress = _React$useState[1];

  var timer = React.useRef(0);

  var handleClose = function handleClose(_event, reason) {
    if (reason === "clickaway" || reason === "escapeKeyDown" || reason === "backdropClick") {
      return;
    }

    onHandleClose(false);
  };

  React.useEffect(function () {
    timer.current = window.setInterval(function () {
      setProgress(function (prevProgress) {
        return prevProgress >= 100 ? 0 : prevProgress + 10;
      });
    }, autoHideDuration / 10);
    return function () {
      clearInterval(timer.current);
    };
  }, []);
  React.useEffect(function () {
    if (progress >= 100 && autohide) {
      onHandleClose(false);
    }
  }, [progress, autohide, open]);
  var severityIcon = setCustomIconDefinition((_severityIcons = severityIcons(severity)) != null ? _severityIcons : "exclamation-circle");
  return React.createElement(Dialog, {
    open: open,
    onClose: handleClose,
    "aria-labelledby": "alert-dialog-title",
    "aria-describedby": "alert-dialog-description",
    keepMounted: true,
    transitionDuration: 1000,
    classes: {
      paper: "NerdNotifierIntrusivePaper"
    }
  }, React.createElement(Stack$1, {
    spacing: 1
  }, autohide && !actions && React.createElement(BorderLinearProgress, {
    variant: "determinate",
    value: progress,
    color: severity
  }), showIcon && React.createElement(Box$1, {
    className: "IntrusiveIcon"
  }, typeof icon === "string" ? React.createElement(NerdIcon, {
    icon: severityIcon,
    severity: severity,
    iconColor: iconColor
  }) : icon, severity && !icon && React.createElement(NerdIcon, {
    icon: severityIcon,
    severity: severity,
    iconColor: colorSwitch(severity)
  })), title && React.createElement(DialogTitle, {
    id: "alert-dialog-title"
  }, title), unstyled ? React.createElement(DialogContent, null, subtitle && React.createElement(DialogContentText, {
    id: "alert-dialog-description"
  }, subtitle), body) : React.createElement(React.Fragment, null, subtitle, body), !autohide && React.createElement(DialogActions, null, React.createElement(Button, Object.assign({
    onClick: handleClose
  }, actionSecondaryProps), "Cancel"), React.createElement(Button, Object.assign({
    onClick: handleClose
  }, actionPrimaryProps), "Ok"))));
}
/**
 *
 * @param severityText
 */

function severityIcons(severityText) {
  switch (severityText) {
    case "error":
      return "times";

    case "info":
      return "exclamation";

    case "success":
      return "check";

    case "warning":
      return "exclamation-triangle";

    default:
      return "";
  }
}

// Generated with util/create-component.js

var NerdNotifier = function NerdNotifier(props) {
  var notification = props.notification,
      children = props.children,
      onClose = props.onClose;
  var _notification$variant = notification.variant,
      variant = _notification$variant === void 0 ? "non-intrusive" : _notification$variant,
      uuid = notification.uuid;

  var _React$useState = React.useState(false),
      open = _React$useState[0],
      setOpen = _React$useState[1];

  React.useEffect(function () {
    if (uuid) {
      setOpen(true);
    }
  }, [uuid]);

  var handleClose = function handleClose() {
    setOpen(false);
    onClose == null ? void 0 : onClose();
  };

  return React.createElement(React.Fragment, null, children, variant === "non-intrusive" && open && React.createElement(NonIntrusive, Object.assign({}, notification, {
    open: open,
    handleClose: handleClose
  })), variant === "intrusive" && React.createElement(Intrusive, Object.assign({}, notification, {
    open: open,
    onHandleClose: handleClose
  })));
};

var css$1 = ".font-size-xl {\n  font-size: 3.5rem;\n}\n\n.font-bold {\n  font-weight: 700;\n}";
n(css$1,{});

var NerdHeadingIcon = function NerdHeadingIcon(_ref) {
  var icon = _ref.icon,
      color = _ref.color,
      iconPosition = _ref.iconPosition;
  return React.createElement(Grid, {
    item: true,
    sx: {
      order: iconPosition === "left" ? 0 : 1,
      color: color
    }
  }, icon);
};

var theme = /*#__PURE__*/createTheme({
  typography: {}
});
theme = /*#__PURE__*/responsiveFontSizes(theme);
var ConditionalWrapper = function ConditionalWrapper(_ref) {
  var condition = _ref.condition,
      wrapper = _ref.wrapper,
      children = _ref.children;
  return React.createElement(ThemeProvider, {
    theme: theme
  }, condition ? wrapper(children) : children);
};

var _excluded = ["text", "display", "variant", "classes", "icon", "color", "children", "iconPosition", "spacing", "alignItems", "uppercase"];
var NerdHeadingComposed = function NerdHeadingComposed(props) {
  var text = props.text,
      display = props.display,
      variant = props.variant,
      classes = props.classes,
      icon = props.icon,
      color = props.color,
      children = props.children,
      _props$iconPosition = props.iconPosition,
      iconPosition = _props$iconPosition === void 0 ? "left" : _props$iconPosition,
      _props$spacing = props.spacing,
      spacing = _props$spacing === void 0 ? 1 : _props$spacing,
      _props$alignItems = props.alignItems,
      alignItems = _props$alignItems === void 0 ? "center" : _props$alignItems,
      uppercase = props.uppercase,
      rest = _objectWithoutPropertiesLoose(props, _excluded);

  return React.createElement(ConditionalWrapper, {
    condition: (text !== "" || typeof children === "string") && icon !== undefined,
    wrapper: function wrapper(childrenContent) {
      return React.createElement(Grid, {
        container: true,
        spacing: spacing,
        alignItems: alignItems
      }, childrenContent);
    }
  }, React.createElement(React.Fragment, null, icon && React.createElement(NerdHeadingIcon, Object.assign({}, {
    icon: icon,
    color: color,
    iconPosition: iconPosition
  })), typeof children === "object" && React.createElement(NerdHeadingIcon, Object.assign({
    icon: children
  }, {
    color: color,
    iconPosition: iconPosition
  })), (typeof children === "string" || text) && React.createElement(Grid, {
    item: true
  }, React.createElement(Typography$1, Object.assign({
    display: display,
    variant: variant,
    classes: classes,
    color: color,
    textTransform: uppercase ? "uppercase" : undefined
  }, rest), typeof children === "string" ? children : text))));
};

var _excluded$1 = ["children", "spacing", "alignItems"];

var NerdHeading = function NerdHeading(props) {
  var children = props.children,
      spacing = props.spacing,
      alignItems = props.alignItems,
      rest = _objectWithoutPropertiesLoose(props, _excluded$1);

  if (Children.count(children) > 0) {
    return React.createElement(Grid, {
      container: true,
      spacing: spacing,
      alignItems: alignItems
    }, Children.map(children, function (child) {
      return React.createElement(NerdHeadingComposed, Object.assign({}, rest), child);
    }));
  }

  return React.createElement(NerdHeadingComposed, Object.assign({}, rest));
};

var NerdHelp = function NerdHelp(_ref) {
  var explanation = _ref.explanation,
      classes = _ref.classes,
      children = _ref.children,
      _ref$anchorOrigin = _ref.anchorOrigin,
      anchorOrigin = _ref$anchorOrigin === void 0 ? {
    vertical: "top",
    horizontal: "left"
  } : _ref$anchorOrigin,
      _ref$transformOrigin = _ref.transformOrigin,
      transformOrigin = _ref$transformOrigin === void 0 ? {
    vertical: "bottom",
    horizontal: "left"
  } : _ref$transformOrigin,
      _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? "body1" : _ref$variant;

  var _React$useState = React.useState(null),
      anchorEl = _React$useState[0],
      setAnchorEl = _React$useState[1];

  var htmlRef = useRef(null);
  var open = Boolean(anchorEl);

  var onMouseEnter = function onMouseEnter() {
    setAnchorEl(htmlRef.current);
  };

  var onMouseLeave = function onMouseLeave() {
    setAnchorEl(null);
  };

  return React.createElement(React.Fragment, null, React.createElement(Box$1, {
    ref: htmlRef,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, children), React.createElement(StyledPopover, {
    sx: {
      pointerEvents: "none"
    },
    open: open,
    anchorEl: anchorEl,
    anchorOrigin: anchorOrigin,
    transformOrigin: transformOrigin,
    classes: _extends({}, classes)
  }, React.createElement(NerdHeading, {
    variant: variant,
    text: explanation,
    sx: {
      p: 1
    }
  })));
};
var StyledPopover = /*#__PURE__*/styled$1(Popover, {
  name: "StyledPopover",
  slot: "Wrapper"
})(function () {
  return {
    width: "100%"
  };
});

var NerdCard = /*#__PURE__*/styled(Paper)(function (_ref) {
  var theme = _ref.theme;
  return {
    borderRadius: theme.spacing(1),
    border: "solid 1px " + theme.palette.divider,
    padding: theme.spacing(2),
    borderLeft: "solid 4px " + theme.palette.primary.main,
    position: "relative",
    width: "100%"
  };
});

var InputAux;

(function (InputAux) {
  InputAux["REQUIRED"] = "required";
})(InputAux || (InputAux = {}));

var AutocompleteType;

(function (AutocompleteType) {
  AutocompleteType["CUSTOMER"] = "customer";
  AutocompleteType["ADDRESS"] = "address";
})(AutocompleteType || (AutocompleteType = {}));

var AutocompleteOnLoadHeading;

(function (AutocompleteOnLoadHeading) {
  AutocompleteOnLoadHeading["CUSTOMER"] = "Type a Customer Name...";
  AutocompleteOnLoadHeading["ADDRESS"] = "Type a Location Name or an Address...";
})(AutocompleteOnLoadHeading || (AutocompleteOnLoadHeading = {}));

var NerdDate = function NerdDate(_ref) {
  var _ref$label = _ref.label,
      label = _ref$label === void 0 ? "" : _ref$label,
      _ref$placeholder = _ref.placeholder,
      placeholder = _ref$placeholder === void 0 ? "" : _ref$placeholder,
      _ref$helperText = _ref.helperText,
      helperText = _ref$helperText === void 0 ? " " : _ref$helperText,
      _ref$required = _ref.required,
      required = _ref$required === void 0 ? false : _ref$required,
      _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? "standard" : _ref$variant,
      onChange = _ref.onChange,
      value = _ref.value;
  return React.createElement(LocalizationProvider, {
    dateAdapter: AdapterMoment
  }, React.createElement(MobileDatePicker, {
    label: label,
    value: value,
    onChange: onChange,
    minDate: moment(),
    renderInput: function renderInput(params) {
      return React.createElement(TextField, Object.assign({}, params, {
        variant: variant,
        placeholder: placeholder,
        InputLabelProps: {
          shrink: true
        },
        helperText: required ? InputAux.REQUIRED : helperText,
        required: required,
        fullWidth: true
      }));
    }
  }));
};

var css$2 = ".Nerd-Text--required .MuiInputLabel-root {\n  display: flex;\n}";
n(css$2,{});

var NerdText = function NerdText(_ref) {
  var _ref$label = _ref.label,
      label = _ref$label === void 0 ? "" : _ref$label,
      _ref$placeholder = _ref.placeholder,
      placeholder = _ref$placeholder === void 0 ? "" : _ref$placeholder,
      id = _ref.id,
      _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? "standard" : _ref$variant,
      required = _ref.required,
      disabled = _ref.disabled,
      error = _ref.error,
      helperText = _ref.helperText,
      value = _ref.value,
      onChange = _ref.onChange,
      onKeyPress = _ref.onKeyPress,
      onBlur = _ref.onBlur,
      onClick = _ref.onClick;
  return React.createElement(TextField, {
    error: error,
    "aria-haspopup": "true",
    disabled: disabled,
    id: id,
    label: label,
    placeholder: placeholder,
    fullWidth: true,
    helperText: required ? InputAux.REQUIRED : helperText,
    required: required,
    value: value,
    onChange: onChange,
    onKeyPress: onKeyPress,
    onBlur: onBlur,
    onClick: onClick,
    InputLabelProps: {
      shrink: true
    },
    variant: variant,
    className: required ? "Nerd-Text--required" : "",
    sx: {
      "& .MuiInputLabel-root": {
        display: "flex"
      }
    }
  });
};

var NerdPassword = function NerdPassword(_ref) {
  var _ref$label = _ref.label,
      label = _ref$label === void 0 ? "" : _ref$label,
      _ref$placeholder = _ref.placeholder,
      placeholder = _ref$placeholder === void 0 ? "" : _ref$placeholder,
      id = _ref.id,
      _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? "standard" : _ref$variant,
      _ref$required = _ref.required,
      required = _ref$required === void 0 ? false : _ref$required,
      disabled = _ref.disabled,
      error = _ref.error,
      helperText = _ref.helperText,
      value = _ref.value,
      onChange = _ref.onChange;
  return React.createElement(TextField, {
    required: required,
    error: error,
    "aria-haspopup": "true",
    disabled: disabled,
    id: id,
    label: label,
    placeholder: placeholder,
    fullWidth: true,
    helperText: required ? required : helperText,
    value: value,
    onChange: onChange,
    InputLabelProps: {
      shrink: true
    },
    variant: variant,
    type: "password"
  });
};

var _excluded$2 = ["type"];
var NerdInput = function NerdInput(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? "text" : _ref$type,
      props = _objectWithoutPropertiesLoose(_ref, _excluded$2);

  var _useState = useState(false),
      close = _useState[0],
      setClose = _useState[1];

  var icon = props.icon,
      _props$spacing = props.spacing,
      spacing = _props$spacing === void 0 ? 1 : _props$spacing,
      disabled = props.disabled,
      fullWidth = props.fullWidth,
      _props$alignItems = props.alignItems,
      alignItems = _props$alignItems === void 0 ? "center" : _props$alignItems,
      _props$inputSize = props.inputSize,
      inputSize = _props$inputSize === void 0 ? 6 : _props$inputSize,
      onChange = props.onChange;
  var sizeWithIcons = fullWidth ? 11 : inputSize;
  var customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
  return React.createElement(ConditionalWrapper, {
    condition: icon !== undefined,
    wrapper: function wrapper(childrenContent) {
      return React.createElement(Grid, {
        container: true,
        spacing: spacing,
        alignItems: alignItems
      }, childrenContent);
    }
  }, React.createElement(React.Fragment, null, icon && React.createElement(Grid, {
    item: true
  }, icon), React.createElement(Grid, {
    item: true,
    sm: customInputSize,
    xs: icon ? 9 : 12
  }, renderNerdInputByType({
    type: type,
    props: props,
    close: close,
    setClose: setClose,
    onChange: onChange
  })), icon && React.createElement(Grid, {
    item: true
  }, React.createElement(IconButton, {
    disabled: disabled,
    size: "small",
    onClick: function onClick() {
      return setClose(true);
    }
  }, React.createElement(CloseIcon, null)))));
};
/**
 * @param auxProps
 * @param auxProps.type
 * @param auxProps.props
 * @param auxProps.close
 * @param auxProps.setClose
 * @param auxProps.onChange
 */

function renderNerdInputByType(auxProps) {
  var type = auxProps.type,
      props = auxProps.props;

  switch (type) {
    case "date":
      return React.createElement(NerdDate, Object.assign({}, props));

    case "text":
      return React.createElement(NerdText, Object.assign({}, props));

    case "password":
      return React.createElement(NerdPassword, Object.assign({}, props));

    default:
      return React.createElement(NerdText, Object.assign({}, props));
  }
}

var css$3 = ".autocompleteSmall {\n  min-width: 40vw;\n  transform: translate(-9vw, -1vh);\n}\n\n@media only screen and (max-width: 600px) {\n  .autocompleteSmall {\n    min-width: 60vw;\n    transform: translate(0vw, 3vh);\n  }\n}";
n(css$3,{});

/**
 * Function to that create a unique id
 *
 * @returns {string} - A unique id as string
 */
function uid() {
  var head = Date.now().toString(36);
  var tail = Math.random().toString(36).slice(2);
  return "" + head + tail;
}
/**
 * @param value
 */

function setAxeValue(value) {
  if (!value) {
    return "-";
  }

  return value.toLowerCase().replace(/\s/g, "-");
}

var _excluded$3 = ["className", "inputValue", "loading", "autocompleteType"];
/**
 * @param { React.HTMLAttributes<HTMLElement> } paperProps - Autocomplete props onLoad
 * @returns { React.ReactElement } - Render react Autocomplete component onLoad
 */

function PaperComponentOnLoad(paperProps) {
  var className = paperProps.className,
      inputValue = paperProps.inputValue,
      loading = paperProps.loading,
      autocompleteType = paperProps.autocompleteType,
      other = _objectWithoutPropertiesLoose(paperProps, _excluded$3);

  return React.createElement(Paper, Object.assign({}, other, {
    className: className ? "autocompleteSmall" : ""
  }), React.createElement(ClickAwayListener, {
    onClickAway: function onClickAway() {
      return console.log("onClick");
    }
  }, React.createElement(React.Fragment, null, inputValue && loading ? React.createElement(WrapperCustomerOnload, null, React.createElement(CircularProgress, {
    color: "primary",
    size: 40
  }), React.createElement(NerdHeading, {
    text: "loading",
    variant: "h6"
  })) : contentOnLoad(autocompleteType, inputValue, loading))));
}

var CustomerOnload = function CustomerOnload() {
  return React.createElement(WrapperCustomerOnload, null, React.createElement(PersonSearchIcon, {
    fontSize: "large"
  }), React.createElement(NerdHeading, {
    text: AutocompleteOnLoadHeading.CUSTOMER,
    variant: "h6"
  }));
};

var AdrressOnload = function AdrressOnload() {
  return React.createElement(React.Fragment, null, React.createElement(WrapperCustomerOnload, null, React.createElement(MapTwoToneIcon, {
    fontSize: "large"
  }), React.createElement(NerdHeading, {
    text: AutocompleteOnLoadHeading.ADDRESS,
    variant: "h6"
  })), React.createElement(Divider, null), React.createElement(Grid, {
    container: true,
    alignItems: "center",
    justifyContent: "center"
  }, React.createElement(Grid, {
    item: true,
    py: 1
  }, React.createElement(Typography, {
    display: "block",
    variant: "caption",
    color: "textSecondary"
  }, "Powered by ", React.createElement("b", null, "Google"), " and ", React.createElement("b", null, "Archer")))));
};

var WrapperCustomerOnload = function WrapperCustomerOnload(props) {
  return React.createElement(Stack, {
    direction: "column",
    justifyContent: "center",
    alignItems: "center",
    spacing: 2,
    py: 7
  }, props.children);
};
/**
 * @param {any} args - content onLoad args
 * @returns {void}
 */


function contentOnLoad() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return args.map(function (arg, i) {
    if (i === 0 && typeof arg === "string" && arg !== "") {
      switch (arg) {
        case AutocompleteType.CUSTOMER:
          return React.createElement(CustomerOnload, {
            key: uid()
          });

        case AutocompleteType.ADDRESS:
          return React.createElement(AdrressOnload, {
            key: uid()
          });
      }
    }

    return React.createElement(React.Fragment, {
      key: uid()
    });
  });
}

var RenderTemplate = function RenderTemplate(_ref) {
  var props = _ref.props,
      option = _ref.option,
      autocompleteType = _ref.autocompleteType,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      _ref$optionsArray = _ref.optionsArray,
      optionsArray = _ref$optionsArray === void 0 ? [] : _ref$optionsArray,
      onClick = _ref.onClick;

  var ListFoot = function ListFoot() {
    return optionsArray[optionsArray.length - 1] === option ? React.createElement(React.Fragment, null, React.createElement(Divider$1, null), React.createElement(Grid, {
      container: true,
      alignItems: "center",
      justifyContent: "center"
    }, React.createElement(Grid, {
      item: true,
      py: 1
    }, React.createElement(Typography$1, {
      display: "block",
      variant: "caption",
      color: "textSecondary"
    }, "Powered by ", React.createElement("b", null, "Google"), " and ", React.createElement("b", null, "Archer"))))) : null;
  };

  return React.createElement(React.Fragment, null, React.createElement(Box, Object.assign({
    key: nanoid(),
    component: "li",
    sx: {
      backgroundColor: "transparent",
      svg: {
        flexShrink: 0,
        color: "white"
      },
      cursor: "pointer",
      "&:hover": {
        backgroundColor: "rgba(0, 0, 0, 0.08)"
      }
    }
  }, props, {
    className: className,
    onClick: onClick
  }), React.createElement(CardHeader, {
    avatar: React.createElement(Avatar, {
      sx: {
        bgcolor: setTemplateIconColorByType(autocompleteType, option)
      },
      "aria-label": autocompleteType
    }, setTemplateIconByType(autocompleteType)),
    title: setTemplateTitle(autocompleteType, option),
    titleTypographyProps: {
      fontWeight: "500",
      variant: "body1"
    },
    subheader: setTemplateContentByType(autocompleteType, option),
    sx: {
      py: 1,
      px: 1
    }
  })), React.createElement(ListFoot, null));
};
/**
 *
 * @param type
 */

function setTemplateIconByType(type) {
  switch (type) {
    case AutocompleteType.CUSTOMER:
      return React.createElement(CorporateFareIcon, {
        fontSize: "medium"
      });

    case AutocompleteType.ADDRESS:
      return React.createElement(LocationOnTwoToneIcon, {
        fontSize: "medium"
      });

    default:
      return React.createElement(CorporateFareIcon, {
        fontSize: "medium"
      });
  }
}
/**
 *
 * @param type
 * @param option
 */


function setTemplateIconColorByType(type, option) {
  switch (type) {
    case AutocompleteType.CUSTOMER:
      return blue[500];

    case AutocompleteType.ADDRESS:
      if (option.name) {
        return blue[500];
      }

      return grey[500];

    default:
      return blue[500];
  }
}
/**
 *
 * @param type
 * @param option
 */


function setTemplateContentByType(type, option) {
  var auxContentCredit = option.credit_on_hold ? " - ( Credit Hold )" : "";
  var auxContentInactivity = option.inactivity_hold ? " - ( Inactivity Hold )" : "";

  switch (type) {
    case AutocompleteType.CUSTOMER:
      return option.line1 + " " + option.state + " " + option.zip + " " + auxContentCredit + " " + auxContentInactivity;

    case AutocompleteType.ADDRESS:
      if (option.structured_formatting) {
        return "" + option.structured_formatting.secondary_text;
      }

      return option.name;

    default:
      return "";
  }
}
/**
 *
 * @param type
 * @param option
 */


function setTemplateTitle(type, option) {
  switch (type) {
    case AutocompleteType.CUSTOMER:
      return "" + option.name;

    case AutocompleteType.ADDRESS:
      if (option.structured_formatting) {
        return "" + option.structured_formatting.main_text;
      }

      return option.name;

    default:
      return "";
  }
}

var NerdAutoComplete = function NerdAutoComplete(_ref) {
  var itemID = _ref.itemID,
      value = _ref.value,
      fullWidth = _ref.fullWidth,
      onChange = _ref.onChange,
      onInputChange = _ref.onInputChange,
      inputValue = _ref.inputValue,
      label = _ref.label,
      placeholder = _ref.placeholder,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? [] : _ref$options,
      _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? "standard" : _ref$variant,
      _ref$required = _ref.required,
      required = _ref$required === void 0 ? false : _ref$required,
      helperText = _ref.helperText,
      loading = _ref.loading,
      _ref$autocompleteType = _ref.autocompleteType,
      autocompleteType = _ref$autocompleteType === void 0 ? AutocompleteType.CUSTOMER : _ref$autocompleteType,
      icon = _ref.icon,
      _ref$spacing = _ref.spacing,
      spacing = _ref$spacing === void 0 ? 1 : _ref$spacing,
      _ref$alignItems = _ref.alignItems,
      alignItems = _ref$alignItems === void 0 ? "center" : _ref$alignItems,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$autoCompleteOpti = _ref.autoCompleteOptionLabel,
      autoCompleteOptionLabel = _ref$autoCompleteOpti === void 0 ? "" : _ref$autoCompleteOpti,
      className = _ref.className,
      _ref$isEditable = _ref.isEditable,
      isEditable = _ref$isEditable === void 0 ? false : _ref$isEditable;

  var _useState = useState(false),
      open = _useState[0],
      setOpen = _useState[1]; // const sizeWithIcons = fullWidth ? 11 : inputSize;
  //const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;


  return React.createElement(ConditionalWrapper, {
    condition: icon !== undefined,
    wrapper: function wrapper(childrenContent) {
      return React.createElement(Grid, {
        container: true,
        spacing: spacing,
        alignItems: alignItems
      }, childrenContent);
    }
  }, React.createElement(React.Fragment, null, icon && React.createElement(Grid, {
    item: true
  }, icon), React.createElement(Grid, {
    item: true,
    sm: true
  }, React.createElement(Autocomplete, {
    id: itemID,
    open: open,
    value: value,
    fullWidth: fullWidth,
    onOpen: function onOpen() {
      return setOpen(true);
    },
    onClose: function onClose() {
      return setOpen(false);
    },
    onChange: onChange,
    onInputChange: onInputChange,
    inputValue: inputValue,
    options: options,
    clearIcon: null,
    getOptionLabel: function getOptionLabel(option) {
      return _getOptionLabel(option, autoCompleteOptionLabel);
    },
    onKeyDown: function onKeyDown(event) {
      if (event.key === "Enter") {
        // Prevent's default 'Enter' behavior.
        event.preventDefault(); // handler code
      }
    },
    renderInput: function renderInput(params) {
      return React.createElement(TextField, Object.assign({}, params, {
        label: label,
        variant: variant,
        placeholder: placeholder,
        InputLabelProps: {
          shrink: true
        },
        InputProps: _extends({}, params.InputProps, {
          endAdornment: null
        }),
        helperText: renderHelperText(required, helperText),
        required: required,
        fullWidth: true
      }));
    },
    renderOption: function renderOption(props, option) {
      return React.createElement(RenderTemplate, Object.assign({}, props, {
        option: option,
        autocompleteType: autocompleteType,
        optionsArray: options
      }));
    },
    PaperComponent: function PaperComponent(props) {
      if (!inputValue || loading) {
        return React.createElement(PaperComponentOnLoad, Object.assign({}, {
          props: props,
          inputValue: inputValue,
          autocompleteType: autocompleteType,
          loading: loading
        }, {
          key: nanoid(),
          className: className ? "autocompleteSmall" : ""
        }));
      }

      return React.createElement(Paper, Object.assign({}, props, {
        key: nanoid(),
        className: className ? "autocompleteSmall" : ""
      }), props.children);
    }
  })), icon && React.createElement(Grid, {
    item: true,
    flexDirection: "column",
    display: "flex"
  }, isEditable && React.createElement(IconButton, {
    disabled: disabled,
    size: "small",
    onClick: function onClick(event) {
      setOpen(false);
      onChange(event, "");
      onInputChange(event, "");
    }
  }, React.createElement(EditIcon, {
    fontSize: "small"
  })), React.createElement(IconButton, {
    disabled: disabled,
    size: "small",
    onClick: function onClick(event) {
      setOpen(false);
      onChange(event, "");
      onInputChange(event, "");
    }
  }, React.createElement(CloseIcon, {
    fontSize: "small"
  })))));
};
/**
 *
 * @param required
 * @param helperText
 */

function renderHelperText(required, helperText) {
  if (!helperText) {
    return "";
  }

  return required ? InputAux.REQUIRED : helperText;
}
/**
 *
 * @param option
 * @param autoCompleteOptionLabel
 */


function _getOptionLabel(option, autoCompleteOptionLabel) {
  if (typeof option === "string") {
    return option;
  }

  if (typeof option === "object" && Object.keys(option).length > 0) {
    return option[autoCompleteOptionLabel];
  }

  return "";
}

/**
 * DataGrid string filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} TextField input for boolean type filter.
 */

function StringOperatorInput(props) {
  var item = props.item,
      applyValue = props.applyValue,
      focusElementRef = props.focusElementRef;
  var ref = React.useRef(null);
  React.useImperativeHandle(focusElementRef, function () {
    return {
      focus: function focus() {
        var _ref$current, _ref$current$querySel;

        ref == null ? void 0 : (_ref$current = ref.current) == null ? void 0 : (_ref$current$querySel = _ref$current.querySelector("input[value=\"" + (item.value || "") + "\"]")) == null ? void 0 : _ref$current$querySel.focus();
      }
    };
  });

  var handleFilterChange = function handleFilterChange(event) {
    applyValue(_extends({}, item, {
      value: event.target.value
    }));
  };

  return React.createElement(TextField$1, {
    name: "custom-filter-operator",
    placeholder: "Value",
    label: "Value",
    variant: "standard",
    InputLabelProps: {
      shrink: true
    },
    value: item.value || "",
    onChange: function onChange(e) {
      return handleFilterChange(e);
    },
    ref: ref
  });
}

/**
 * DataGrid date filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} DatePicker input for date type filter.
 */

function DateOperatorInput(props) {
  var item = props.item,
      applyValue = props.applyValue,
      focusElementRef = props.focusElementRef;
  var ref = React.useRef(null);
  React.useImperativeHandle(focusElementRef, function () {
    return {
      focus: function focus() {
        var _ref$current, _ref$current$querySel;

        ref == null ? void 0 : (_ref$current = ref.current) == null ? void 0 : (_ref$current$querySel = _ref$current.querySelector("input[value=\"" + (item.value || "") + "\"]")) == null ? void 0 : _ref$current$querySel.focus();
      }
    };
  });

  var handleFilterChange = function handleFilterChange(value) {
    applyValue(_extends({}, item, {
      value: value ? value.format("YYYY-MM-DD") : ""
    }));
  };

  return React.createElement(LocalizationProvider, {
    dateAdapter: AdapterMoment
  }, React.createElement(DatePicker, {
    inputFormat: "YYYY/MM/DD",
    mask: "____/__/__",
    label: "Value",
    value: item.value || "",
    onChange: function onChange(value) {
      return handleFilterChange(value);
    },
    ref: ref,
    renderInput: function renderInput(params) {
      return React.createElement(TextField$1, Object.assign({}, params, {
        placeholder: "Value",
        label: "Value",
        variant: "standard"
      }));
    }
  }));
}

/**
 * DataGrid boolean filter input.
 *
 * @param {GridFilterInputValueProps} props Component props
 * @returns {React.ReactElement} CheckBox input for boolean type filter.
 */

function BoolOperatorInput(props) {
  var item = props.item,
      applyValue = props.applyValue,
      focusElementRef = props.focusElementRef;
  var ref = React.useRef(null);
  React.useImperativeHandle(focusElementRef, function () {
    return {
      focus: function focus() {
        var _ref$current, _ref$current$querySel;

        ref == null ? void 0 : (_ref$current = ref.current) == null ? void 0 : (_ref$current$querySel = _ref$current.querySelector("input[value=\"" + (item.value || "") + "\"]")) == null ? void 0 : _ref$current$querySel.focus();
      }
    };
  });

  var handleFilterChange = function handleFilterChange(event) {
    applyValue(_extends({}, item, {
      value: event.target.checked
    }));
  };

  return React.createElement(FormGroup, {
    sx: {
      justifyContent: "center"
    }
  }, React.createElement(FormControlLabel, {
    control: React.createElement(Checkbox, {
      name: "custom-filter-operator",
      placeholder: "Value",
      checked: item.value || false,
      onChange: function onChange(e) {
        return handleFilterChange(e);
      }
    }),
    label: "Active"
  }));
}

var CustomArrow = function CustomArrow(_ref) {
  var onPageChange = _ref.onPageChange,
      page = _ref.page,
      disabledNext = _ref.disabledNext,
      children = _ref.children;
  var disablePrev = page === 1;
  return React.createElement(Box$2, null, React.createElement(Tooltip, {
    title: "First Page",
    placement: "bottom",
    enterDelay: 300
  }, React.createElement("span", null, React.createElement(IconButton$1, {
    onClick: function onClick(e) {
      return onPageChange(e, 1);
    },
    disabled: disablePrev,
    "aria-label": "First Page"
  }, React.createElement(FirstPage, null)))), React.createElement(Tooltip, {
    title: "Prev Page",
    placement: "bottom",
    enterDelay: 300
  }, React.createElement("span", null, React.createElement(IconButton$1, {
    onClick: function onClick(e) {
      return onPageChange(e, page - 1);
    },
    disabled: disablePrev,
    "aria-label": "Previous Page"
  }, React.createElement(KeyboardArrowLeft, null)))), children, React.createElement(Tooltip, {
    title: "Next Page",
    placement: "bottom",
    enterDelay: 300
  }, React.createElement("span", null, React.createElement(IconButton$1, {
    onClick: function onClick(e) {
      onPageChange(e, page + 1);
    },
    "aria-label": "Next Page",
    disabled: disabledNext
  }, React.createElement(KeyboardArrowRight, null)))));
};

var css$4 = "@charset \"UTF-8\";\n.nerdUI {\n  /* Other screens */\n  /* mobile devices*/\n}\n.nerdUI--pagination .MuiToolbar-root .MuiTablePagination-spacer {\n  display: none;\n}\n.nerdUI--pagination .MuiToolbar-root .paginationContainer {\n  flex-wrap: nowrap;\n}\n.nerdUI--pagination-sm .MuiToolbar-root {\n  flex-wrap: wrap;\n  justify-content: center;\n}\n.nerdUI--pagination-sm .MuiToolbar-root .paginationContainer {\n  justify-content: center;\n}\n.nerdUI--pagination-pages .MuiPagination-roo  {\n  display: inline;\n}\n.nerdUI--pagination-pages .MuiPagination-roo  .MuiPagination-ul {\n  display: inline;\n}\n.nerdUI--pagination-pages .MuiPagination-roo  .MuiPagination-ul li {\n  display: inline;\n}";
n(css$4,{});

var PageActions = function PageActions(props) {
  var page = props.page,
      onPageChange = props.onPageChange,
      selectPages = props.selectPages,
      disabledNext = props.disabledNext;
  var pagesStored = [].concat(Array.from(new Set(selectPages.sort(function (a, b) {
    return a - b;
  }))));
  var theme = useTheme();
  var matches = useMediaQuery(theme.breakpoints.down("sm"));
  return React.createElement(Grid, {
    container: true,
    alignItems: "center",
    className: "paginationContainer",
    sx: {
      marginLeft: "1rem"
    }
  }, React.createElement(Grid, {
    item: true
  }, React.createElement(CustomArrow, Object.assign({}, {
    onPageChange: onPageChange,
    page: page,
    disabledNext: disabledNext,
    pagesStored: pagesStored
  }), React.createElement(Pagination, {
    count: pagesStored[pagesStored.length - 1],
    defaultPage: page,
    siblingCount: matches ? 0 : 1,
    size: matches ? "small" : "medium",
    hideNextButton: true,
    hidePrevButton: true,
    sx: {
      display: "inline",
      "&.MuiPagination-root *": {
        display: "inline"
      }
    },
    onChange: function onChange(event, page) {
      onPageChange(event, page);
    }
  }))));
};

var nerdPaginationAuxContent;

(function (nerdPaginationAuxContent) {
  nerdPaginationAuxContent["Rows"] = "Rows";
})(nerdPaginationAuxContent || (nerdPaginationAuxContent = {}));

var NerdPagination = function NerdPagination(_ref) {
  var page = _ref.page,
      rowsPerPage = _ref.rowsPerPage,
      rowPageOptions = _ref.rowPageOptions,
      selectPages = _ref.selectPages,
      disabledNext = _ref.disabledNext,
      handleChangePage = _ref.handleChangePage,
      handleChangeRowsPerPage = _ref.handleChangeRowsPerPage;
  var theme = useTheme$1();
  var matches = useMediaQuery$1(theme.breakpoints.down("sm"));
  return React.createElement(TablePagination, {
    component: "div",
    count: -1,
    page: page,
    onPageChange: handleChangePage,
    rowsPerPage: rowsPerPage,
    rowsPerPageOptions: rowPageOptions,
    onRowsPerPageChange: handleChangeRowsPerPage,
    ActionsComponent: function ActionsComponent(props) {
      return React.createElement(PageActions, Object.assign({
        selectPages: selectPages,
        disabledNext: disabledNext
      }, props));
    },
    labelDisplayedRows: function labelDisplayedRows() {
      return "";
    },
    labelRowsPerPage: nerdPaginationAuxContent.Rows,
    getItemAriaLabel: function getItemAriaLabel(type) {
      return "Go to " + type + " page";
    },
    backIconButtonProps: {
      "aria-label": "Previous Page"
    },
    nextIconButtonProps: {
      "aria-label": "Next Page"
    },
    className: "nerdUI--pagination " + (matches ? "nerdUI--pagination-sm" : "")
  });
};

var OPERATORS = {
  eq: {
    label: "Equal",
    value: "eq"
  },
  neq: {
    label: "Not Equal",
    value: "neq"
  },
  gt: {
    label: "Greater Than",
    value: "gt"
  },
  lt: {
    label: "Less Than",
    value: "lt"
  },
  gte: {
    label: "Greater or Equal Than",
    value: "gte"
  },
  lte: {
    label: "Less or Equal Than",
    value: "lte"
  },
  like: {
    label: "Like",
    value: "like"
  }
};
/**
 * NerdGrid component.
 *
 * @param {propsType} props nerdGrid props.
 * @returns {React.ReactElement} DataGrid wrapper with server-side filters.
 */

function NerdGrid(props) {
  var columnsVisibility = props.columnsVisibility,
      columns = props.columns,
      networkCompletionStack = props.networkCompletionStack,
      dispatch = props.dispatch,
      queryBuilder = props.queryBuilder,
      getRows = props.getRows,
      culumnsMatchingFilterName = props.culumnsMatchingFilterName,
      hidePagination = props.hidePagination,
      hideFilters = props.hideFilters,
      defaultSelectRowID = props.defaultSelectRowID,
      createNewButton = props.createNewButton;
  var rows = props.rows;
  var rowPageOptions = useMemo(function () {
    return [10, 50, 100];
  }, []);
  var limit;
  var offset;
  var filters;

  if (queryBuilder) {
    var queryParams = queryBuilder.getQuery();
    limit = queryParams["limit"];
    offset = queryParams["offset"];
    filters = queryParams["filters"];
  }

  var _useState = useState(10),
      rowsPerPage = _useState[0],
      setRowsPerPage = _useState[1];

  var _useState2 = useState(1),
      page = _useState2[0],
      setPage = _useState2[1];

  var _useState3 = useState([0]),
      selectPages = _useState3[0],
      setSelectPages = _useState3[1];

  var _useState4 = useState(false),
      disabledNext = _useState4[0],
      setDisabledNext = _useState4[1];

  var _React$useState = React.useState(undefined),
      rowCount = _React$useState[0],
      setRowCount = _React$useState[1];

  var _React$useState2 = React.useState(rowCount || 0),
      rowCountState = _React$useState2[0],
      setRowCountState = _React$useState2[1];

  var _useState5 = useState(culumnsMatchingFilterName ? {
    filters: filters ? filters : "",
    limit: Number(limit) ? Number(limit) : rowsPerPage,
    offset: Number(offset) ? Number(offset) : 0
  } : {
    limit: Number(limit) ? Number(limit) : rowsPerPage,
    offset: Number(offset) ? Number(offset) : 0
  }),
      queryObject = _useState5[0],
      setQueryObject = _useState5[1];

  var _useState6 = useState(false),
      requestPending = _useState6[0],
      setRequestPending = _useState6[1];

  var _useState7 = useState(""),
      requestUUID = _useState7[0],
      setRequestUUID = _useState7[1];

  var _useState8 = useState({
    items: [],
    linkOperator: GridLinkOperator.And
  }),
      filterModel = _useState8[0],
      setFilterModel = _useState8[1];

  var _useState9 = useState(defaultSelectRowID && rows.filter(function (row) {
    return row["id"] === defaultSelectRowID;
  }).length > 0 ? [defaultSelectRowID] : []),
      selectionModel = _useState9[0],
      setSelectionModel = _useState9[1];

  var prevSelectionModel = React.useRef(defaultSelectRowID ? [defaultSelectRowID] : []);
  /**
   * Custom MUI Grid Toolbar
   *
   * @returns {React.ReactElement} Mui Grid Toolbar
   */

  function CustomToolbar() {
    return React.createElement(GridToolbarContainer, null, !hideFilters && React.createElement(GridToolbarFilterButton, null), props.apiExportEndpoint && React.createElement(Button$1, {
      sx: {
        fontSize: "0.8125rem"
      },
      variant: "text",
      startIcon: React.createElement(SaveAlt, null),
      onClick: function onClick() {
        var a = encodeURI("" + props.apiExportEndpoint + ("filters" in queryObject ? "?filters=" + queryObject.filters : ""));
        window.open(a, "_blank", "noopener,noreferrer");
      }
    }, "EXPORT"), createNewButton);
  }

  useEffect(function () {
    try {
      if (culumnsMatchingFilterName && filters) {
        var filtersObject = JSON.parse(filters);
        var filterModelTmp = {
          items: [],
          linkOperator: GridLinkOperator.And
        };
        Array.isArray(filtersObject) && filtersObject.forEach(function (filter, i) {
          var columnField = "";

          for (var _iterator = _createForOfIteratorHelperLoose(culumnsMatchingFilterName.entries()), _step; !(_step = _iterator()).done;) {
            var _step$value = _step.value,
                key = _step$value[0],
                value = _step$value[1];
            if (value === filter.name) columnField = key;
          }

          filterModelTmp.items.push({
            id: i + 1,
            columnField: columnField,
            value: filter.value,
            operatorValue: filter.comparison
          });
        });
        setFilterModel(filterModelTmp);
      }
    } catch (error) {
      return;
    }
  }, []); // Set URL query

  useEffect(function () {
    if (queryBuilder) {
      if (Number(offset) % Number(limit) !== 0 || !rowPageOptions.includes(Number(limit))) {
        setQueryObject(_extends({}, queryObject, {
          limit: 10,
          offset: 0
        }));
        setPage(1);
        setRowsPerPage(10);
      } else if (Number(limit) === queryObject.limit) {
        setPage(Number(offset) / Number(limit) + 1);
        setRowsPerPage(Number(limit));
      }

      queryBuilder.setUrlQuery(queryObject);
    }
  }, [offset, limit, rowPageOptions, queryObject, queryBuilder]);
  /**
   * Return DataGrid filter operators for a given column type.
   *
   * @param {string | undefined} type Type of the column.
   * @returns {Array<GridFilterOperator>} Return filter operators.
   */

  function operatorsByType(type) {
    var operators = [];
    var input;

    switch (type) {
      case "date":
        input = DateOperatorInput;
        break;

      case "boolean":
        input = BoolOperatorInput;
        break;

      default:
        input = StringOperatorInput;
        break;
    }

    Object.entries(OPERATORS).forEach(function (val) {
      return operators.push({
        label: val[1].label,
        value: val[1].value,
        getApplyFilterFn: function getApplyFilterFn() {
          //ServerSide filter, so we don't need filter function here.
          return function () {
            return true;
          };
        },
        InputComponent: input
      });
    });
    return operators;
  }

  var setCustomPagination = useCallback(function () {
    if (Number(offset) > 0 || Number(limit) > 0) {
      setSelectPages(function (prevState) {
        return [].concat(Array.from(new Set(prevState)), Array(page).fill(0).map(function (_e, i) {
          return i + 1;
        }));
      });
    }
  }, [limit, offset, page]);
  var columnsWithOperators = React.useMemo(function () {
    return columns.map(function (col) {
      return _extends({}, col, {
        filterOperators: operatorsByType(col.type)
      });
    });
  }, [columns]);
  useEffect(function () {
    if (dispatch && getRows) {
      setRequestPending(true);
      setRowCount(undefined);
      var uuid = withNetworkCompletionDispatch(dispatch, getRows(queryObject));
      setRequestUUID(uuid);
    }
  }, [dispatch, getRows, queryObject]); // Check if API call ends and close loading

  useEffect(function () {
    if (networkCompletionStack) {
      if (requestUUID !== "" && !networkCompletionStack.some(function (e) {
        return e[requestUUID];
      })) {
        setRequestUUID("");
        setRequestPending(false);
        setRowCount(rows.length); //restore selection model after page change

        setSelectionModel(prevSelectionModel.current);
      }

      setCustomPagination();
    }
  }, [requestUUID, networkCompletionStack, setCustomPagination, rows.length]);
  var onFilterChange = React.useCallback(function (newFilterModel) {
    if (culumnsMatchingFilterName) {
      var _filters = [];
      newFilterModel.items.forEach(function (item) {
        var searchMetadataName = culumnsMatchingFilterName.get(item.columnField);

        if (item.operatorValue && item.value !== undefined && item.value !== "" && searchMetadataName) {
          _filters.push({
            name: searchMetadataName,
            comparison: item.operatorValue,
            value: item.value
          });
        }
      });
      setPage(1); // Reset page to 1

      setSelectPages([0]); // Reset select pages

      setQueryObject({
        limit: queryObject.limit,
        offset: 0,
        filters: JSON.stringify(_filters)
      });
      setFilterModel(newFilterModel);
    }
  }, [culumnsMatchingFilterName, queryObject.limit]);
  /**
   * Set new page value and change the query object
   *
   * @param {React.MouseEvent<HTMLButtonElement> | null} _event ChangePage
   * @param {number} newPage New page index
   */

  function handleChangePage(_event, newPage) {
    prevSelectionModel.current = selectionModel;
    setPage(newPage);

    if (newPage > 0) {
      setQueryObject(_extends({}, queryObject, {
        offset: (newPage - 1) * Number(limit)
      }));
    }
  }
  /**
   * @param {ChangeEvent<HTMLInputElement | HTMLTextAreaElement>} event - new rows page number selected
   */


  function handleChangeRowsPerPage(event) {
    var newPage = parseInt(event.target.value, 10);
    setRowsPerPage(newPage); // set new page size

    setPage(1); // Reset page to 1

    setSelectPages([0]); // Reset select pages
    // Set new query object

    setQueryObject(function (prevState) {
      return _extends({}, prevState, {
        limit: newPage,
        offset: 0
      });
    });
  }
  /**
   *
   * @param {GridSelectionModel} ids Selected rows
   */


  function onSelectionModelChange(ids) {
    var selectedIDs = new Set(ids);
    var selectedRows = rows.filter(function (row) {
      return selectedIDs.has(row.id);
    });
    var prevSelectedIDs = new Set(prevSelectionModel.current); //Don't call onSelect if page changed

    if (ids.length === 0) {
      if (rows.filter(function (row) {
        return prevSelectedIDs.has(row.id);
      }).length > 0) {
        props.onSelect == null ? void 0 : props.onSelect(selectedRows);
      }
    } else {
      props.onSelect == null ? void 0 : props.onSelect(selectedRows);
    }

    setSelectionModel(ids);
  }

  React.useEffect(function () {
    setRowCountState(function (prevRowCountState) {
      return rowCount !== undefined ? rowCount : prevRowCountState;
    });
  }, [rowCount, setRowCountState]);
  return React.createElement(DataGridPro, {
    sx: {
      "&.MuiDataGrid-root .MuiDataGrid-cell:focus": {
        outline: "none"
      },
      paddingTop: "0px",
      width: "100%",
      height: "700px"
    },
    pageSize: rowsPerPage,
    rowsPerPageOptions: rowPageOptions,
    onStateChange: function onStateChange(state) {
      var _state$pagination = state.pagination,
          rowCount = _state$pagination.rowCount,
          pageSize = _state$pagination.pageSize;
      setDisabledNext(rowCount < pageSize);
    },
    pagination: true,
    paginationMode: "server",
    rowCount: rowCountState,
    hideFooterPagination: hidePagination,
    components: {
      Toolbar: CustomToolbar,
      Pagination: NerdPagination
    },
    componentsProps: {
      filterPanel: {
        linkOperators: ["and"]
      },
      pagination: {
        rowsPerPage: rowsPerPage,
        handleChangeRowsPerPage: handleChangeRowsPerPage,
        rowPageOptions: rowPageOptions,
        handleChangePage: handleChangePage,
        page: page,
        selectPages: selectPages,
        disabledNext: disabledNext
      }
    },
    onSelectionModelChange: onSelectionModelChange,
    rows: rows,
    columns: columnsWithOperators,
    loading: requestPending,
    filterMode: "server",
    onFilterModelChange: onFilterChange,
    initialState: {
      columns: {
        columnVisibilityModel: columnsVisibility
      }
    },
    filterModel: filterModel,
    selectionModel: selectionModel
  });
}

var notificationInitialState = {
  notification: {
    uuid: ""
  }
};
var notificationSlice = /*#__PURE__*/createSlice({
  name: "notification",
  initialState: notificationInitialState,
  reducers: {
    showNotification: function showNotification(_state, action) {
      return _extends({}, action.payload);
    },
    clearNotification: function clearNotification() {
      return notificationInitialState;
    }
  }
});
var _notificationSlice$ac = notificationSlice.actions,
    showNotification = _notificationSlice$ac.showNotification,
    clearNotification = _notificationSlice$ac.clearNotification;
var notificationReducer = notificationSlice.reducer;

export { AutocompleteOnLoadHeading, AutocompleteType, ConditionalWrapper, InputAux, NerdAutoComplete, NerdCard, NerdGrid, NerdHeading, NerdHelp, NerdIcon, NerdInput, NerdNotifier, NerdPagination, clearNotification, colorSwitch, nerdPaginationAuxContent, notificationInitialState, notificationReducer, notificationSlice, setAxeValue, setCustomIconDefinition, showNotification, uid };
//# sourceMappingURL=nerd-ui.esm.js.map
