import React from "react";
import { GridColDef } from "@mui/x-data-grid-pro";
import { GetAction, QueryBuilder } from "@nerdjs/nerd-network";
import { ActionCreatorWithPreparedPayload, Dispatch } from "@reduxjs/toolkit";
declare type commonProps = {
    rows: object[];
    columns: GridColDef[];
    columnsVisibility?: {
        [key: string]: boolean;
    };
    onSelect?: (selectedRows: {
        [key: string]: unknown;
    }[]) => void;
    apiExportEndpoint?: string;
    defaultSelectRowID?: number;
    createNewButton?: JSX.Element;
};
declare type optionalProps = {
    hidePagination?: false;
    hideFilters?: false;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName: Map<string, string>;
    getRows: ActionCreatorWithPreparedPayload<[{
        [key: string]: unknown;
    }], {
        id: string;
        createdAt: string;
        request: GetAction;
    }>;
    dispatch: Dispatch;
    queryBuilder: QueryBuilder;
    networkCompletionStack: Record<string, boolean>[];
} | {
    hidePagination: true;
    hideFilters: true;
    culumnsMatchingFilterName?: never;
    getRows?: never;
    dispatch?: never;
    queryBuilder?: never;
    networkCompletionStack?: never;
} | {
    hidePagination: true;
    hideFilters?: false;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName: Map<string, string>;
    getRows: ActionCreatorWithPreparedPayload<[{
        [key: string]: unknown;
    }], {
        id: string;
        createdAt: string;
        request: GetAction;
    }>;
    dispatch: Dispatch;
    queryBuilder: QueryBuilder;
    networkCompletionStack: Record<string, boolean>[];
} | {
    hidePagination?: false;
    hideFilters: true;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName?: never;
    getRows: ActionCreatorWithPreparedPayload<[{
        [key: string]: unknown;
    }], {
        id: string;
        createdAt: string;
        request: GetAction;
    }>;
    dispatch: Dispatch;
    queryBuilder: QueryBuilder;
    networkCompletionStack: Record<string, boolean>[];
};
declare type propsType = commonProps & optionalProps;
/**
 * NerdGrid component.
 *
 * @param {propsType} props nerdGrid props.
 * @returns {React.ReactElement} DataGrid wrapper with server-side filters.
 */
declare function NerdGrid(props: propsType): React.ReactElement;
export default NerdGrid;
