import { SyntheticEvent } from "react";
import { AutocompleteType } from "../NerdInput/NerdInputEnums";

// export interface ICustomer {
//   id?: number;
//   name?: string;
//   company_id?: number;
//   credit_on_hold?: boolean;
//   inactivity_hold?: boolean;
//   credit_term_id?: number;
//   line1?: string;
//   city?: string;
//   state?: string;
//   zip?: string;
//   is_active?: boolean;
//   credit_term_name?: unknown;
// }

export interface INerdAutoComplete {
  itemID: string;
  value: string;
  fullWidth?: boolean;
  onChange: (event: SyntheticEvent<Element, Event>, newValue: any) => void;
  onInputChange: (
    event: SyntheticEvent<Element, Event>,
    newInputValue: any
  ) => void;
  inputValue: string;
  label: string;
  placeholder: string;
  options: any[];
  variant?: "standard" | "outlined" | "filled";
  required?: boolean;
  helperText?: React.ReactNode;
  loading?: boolean;
  autocompleteType?: AutocompleteType.CUSTOMER | AutocompleteType.ADDRESS;
  icon?: React.ReactNode;
  spacing?: number;
  alignItems?: "flex-start" | "center" | "flex-end";
  disabled?: boolean;
  inputSize?: number;
  autoCompleteOptionLabel?: string;
  className?: unknown;
  isEditable?: boolean;
}

export type WrapperCustomerOnloadProps = {
  children?: React.ReactNode;
};
