// Generated with util/create-component.js
import Grid from "@mui/material/Grid";
import { ComponentStory } from "@storybook/react";
import React from "react";
import { NerdIcon } from "../shared/NerdIcon/NerdIcon";
import NerdHeading from "./NerdHeading";
export default {
  title: "NerdHeading",
  component: NerdHeading,
  argTypes: {
    color: {
      options: ["primary", "secondary", "inherit"],
      control: { type: "select" },
    },
  },
};

const TemplateNerdHeading: ComponentStory<typeof NerdHeading> = (args) => (
  <NerdHeading {...args} />
);

export const NerdHeadingNoIcon: ComponentStory<typeof NerdHeading> =
  TemplateNerdHeading.bind({});

// Display limited number of controls in the controls panel,
NerdHeadingNoIcon.parameters = {
  controls: { include: ["text", "variant", "color"] },
};

// Set the default values of the controls
NerdHeadingNoIcon.args = {
  text: "Lorem Ipsum No icon",
  variant: "h4",
};

// NerdHeading with icon
const TemplateNerdHeadingGrid: ComponentStory<typeof NerdHeading> = (args) => (
  <Grid container spacing={2} alignItems="center">
    <NerdHeading {...args} />
  </Grid>
);

export const NerdHeadingIcon: ComponentStory<typeof NerdHeading> =
  TemplateNerdHeadingGrid.bind({});

NerdHeadingIcon.parameters = {
  controls: { include: ["text", "variant", "icon", "color"] },
};

// Set the default values of the controls
NerdHeadingIcon.args = {
  text: "Lorem Ipsum Icon",
  variant: "h3",
  icon: <NerdIcon icon={"bell"} iconColor={"black"} size="lg" />,
};
