import React, { ReactElement } from "react";
import MobileDatePicker from "@mui/lab/MobileDatePicker";
import LocalizationProvider from "@mui/lab/LocalizationProvider";
import { AdapterMoment } from "@mui/x-date-pickers/AdapterMoment";
import TextField, { TextFieldProps } from "@mui/material/TextField";
import { InputAux } from "../NerdInputEnums";
import { INerdDate } from "./typings";
import moment from "moment";

export const NerdDate = ({
  label = "",
  placeholder = "",
  helperText = " ",
  required = false,
  variant = "standard",
  onChange,
  value,
}: TextFieldProps & INerdDate): ReactElement => {
  return (
    <LocalizationProvider dateAdapter={AdapterMoment}>
      <MobileDatePicker
        label={label}
        value={value}
        onChange={onChange}
        minDate={moment()}
        renderInput={(params) => (
          <TextField
            {...params}
            variant={variant}
            placeholder={placeholder}
            InputLabelProps={{
              shrink: true,
            }}
            helperText={required ? InputAux.REQUIRED : helperText}
            required={required}
            fullWidth
          />
        )}
      />
    </LocalizationProvider>
  );
};
