import TextField, { TextFieldProps } from "@mui/material/TextField";
import React from "react";
import { InputAux } from "../NerdInputEnums";
import { INerdInputText } from "../typings";
import "./NerdText.scss";

export const NerdText = ({
  label = "",
  placeholder = "",
  id,
  variant = "standard",
  required,
  disabled,
  error,
  helperText,
  value,
  onChange,
  onKeyPress,
  onBlur,
  onClick,
}: INerdInputText & TextFieldProps) => {
  return (
    <TextField
      error={error}
      aria-haspopup="true"
      disabled={disabled}
      id={id}
      label={label}
      placeholder={placeholder}
      fullWidth
      helperText={required ? InputAux.REQUIRED : helperText}
      required={required}
      value={value}
      onChange={onChange}
      onKeyPress={onKeyPress}
      onBlur={onBlur}
      onClick={onClick}
      InputLabelProps={{
        shrink: true,
      }}
      variant={variant}
      className={required ? "Nerd-Text--required" : ""}
      sx={{
        "& .MuiInputLabel-root": {
          display: "flex",
        },
      }}
    />
  );
};
