// Generated with util/create-component.js
import Button from "@mui/material/Button";
import React from "react";
import { NonIntrusive } from "./components/NonIntrusive";
import { Intrusive } from "./components/Intrusive";
import NerdNotifier from "./NerdNotifier";
export default {
  title: "NerdNotifier",
  component: NerdNotifier,
  argTypes: {
    severity: {
      options: ["info", "error", "warning", "success"],
      control: { type: "radio" },
    },
    onClose: { action: "clicked onClose" },
    onClick: { action: "clicked" },
  },
};

const Actions = () => {
  return (
    <>
      <Button
        onClick={() => {
          console.log("click btn ok");
        }}
      >
        Ok
      </Button>
      <Button
        onClick={() => {
          console.log("click btn cancel");
        }}
      >
        cancel
      </Button>
    </>
  );
};

const TemplateNonIntrusive = (args) => <NonIntrusive {...args} />;

const Template = (args) => <Intrusive {...args} />;

export const NonIntrusiveNotifier = TemplateNonIntrusive.bind({});
NonIntrusiveNotifier.args = {
  uuid: "test-uuid-123456789",
  title: "Test title Non-Intrusive",
  subtitle: "Test subtitle Non-Intrusive",
  body: "Test body Non-Intrusive",
  open: false,
  autohide: true,
  autoHideDuration: 5000,
  handleClose: (e: React.MouseEvent<HTMLButtonElement>) => console.log(e),
};

NonIntrusiveNotifier.parameters = {
  notification: {},
};

export const IntrusiveNotifier = Template.bind({});
IntrusiveNotifier.args = {
  variant: "intrusive",
  uuid: "test-uuid-123456789",
  title: "Test title Intrusive",
  subtitle: "Test subtitle Intrusive",
  body: "Test body Intrusive",
  icon: "check",
  open: false,
  autohide: true,
  autoHideDuration: 5000,
  setOpen: () => {
    console.log("Open notifier");
  },
  iconColor: "",
  actions: <Actions />,
};
