// Generated with util/create-component.js
import React, { ReactElement } from "react";
import { NerdNotifierProps } from "./typings";
import { NonIntrusive } from "./components/NonIntrusive";
import { Intrusive } from "./components/Intrusive";

const NerdNotifier = (props: NerdNotifierProps): ReactElement => {
  const { notification, children, onClose } = props;
  const { variant = "non-intrusive", uuid } = notification;
  const [open, setOpen] = React.useState(false);

  React.useEffect(() => {
    if (uuid) {
      setOpen(true);
    }
  }, [uuid]);

  const handleClose = () => {
    setOpen(false);
    onClose?.();
  };

  return (
    <React.Fragment>
      {children}
      {variant === "non-intrusive" && open && (
        <NonIntrusive {...notification} open={open} handleClose={handleClose} />
      )}
      {variant === "intrusive" && (
        <Intrusive {...notification} open={open} onHandleClose={handleClose} />
      )}
    </React.Fragment>
  );
};

export default NerdNotifier;
