import { styled, Theme } from "@mui/material/styles";
import React from "react";
import LinearProgress, {
  linearProgressClasses,
  LinearProgressProps,
} from "@mui/material/LinearProgress";
import { StyledComponent } from "@emotion/styled/types/base";
import { MUIStyledCommonProps } from "@mui/system";

const BorderLinearProgress: StyledComponent<
  LinearProgressProps & MUIStyledCommonProps<Theme>,
  Record<string, unknown>,
  Record<string, unknown>
> = styled((props: LinearProgressProps) => (
  <LinearProgress
    variant={props.variant}
    value={props.value}
    color={props.color ?? "info"}
  />
))(({ theme }) => ({
  height: 5,
  borderRadius: 5,
  [`&.${linearProgressClasses.colorPrimary}`]: {
    backgroundColor:
      theme.palette.grey[theme.palette.mode === "light" ? 200 : 800],
  },
  [`& .${linearProgressClasses.bar}`]: {
    borderRadius: 5,
    backgroundColor: theme.palette.mode === "light" ? "#1a90ff" : "#308fe8",
  },
}));

export default BorderLinearProgress;
